classification
Title: Add .tostring() method to xml.etree.ElementTree.Element
Type: enhancement Stage: resolved
Components: XML Versions: Python 3.6
process
Status: closed Resolution: rejected
Dependencies: Superseder:
Assigned To: Nosy List: iritkatriel, scoder, serhiy.storchaka, stevoisiak
Priority: normal Keywords:

Created on 2018-05-17 17:13 by stevoisiak, last changed 2020-09-18 07:08 by serhiy.storchaka. This issue is now closed.

Messages (4)
msg316966 - (view) Author: Steven Vascellaro (stevoisiak) * Date: 2018-05-17 17:13
In Python 3.6, converting an xml `xml.etree.ElementTree.Element` to a string is done using `xml.etree.ElementTree.tostring()`.

```
from xml.etree import ElementTree

xml = ElementTree.Element('Person', Name='John')
print(ElementTree.tostring(xml, encoding='unicode', method='xml')
# Output: <Person Name="John" />
```

I would like to propose adding a `tostring()` function to the `Element` class, so that `ElementTree.tostring(xml)` could be replaced with the more intuitive `xml.tostring()`.

```
from xml.etree import ElementTree

xml = ElementTree.Element('Person', Name='John')
print(xml.tostring(encoding='unicode', method='xml'))
# Output: <Person Name="John" />
```

Benefits:

- Doesn't require importing `xml.etree.ElementTree`
- Allows writing more concise code
- Makes `tostring` part of the `Element` class
- Maintains backwards compatibility
msg316969 - (view) Author: Steven Vascellaro (stevoisiak) * Date: 2018-05-17 17:45
Alternatively, the most intuitive solution would be to give `Element` an explicit `__str__` method.

The current behavior of `str(Element)` is to return the object's location in memory.

```
from xml.etree import ElementTree

xml = ElementTree.Element('Person', Name='John')
print(str(xml))
# Output: <Element 'Person' at 0x028575D0>
```

Unfortunately, changing this behavior could cause issues with backwards compatibility.
msg316975 - (view) Author: Stefan Behnel (scoder) * (Python committer) Date: 2018-05-17 18:43
Sorry, but you are proposing an API extension here that provides no benefits but duplicates existing functionality in a less versatile place. This is not going to happen.

The second proposal (str(xml)) is actually not very helpful as it does not allow any kind of configuration, so it breaks backwards compatibility without benefit. Also not going to happen.
msg377073 - (view) Author: Irit Katriel (iritkatriel) * (Python committer) Date: 2020-09-17 23:14
Should this issue be closed as 'rejected', or is there anything left to do?
History
Date User Action Args
2020-09-18 07:08:25serhiy.storchakasetstatus: open -> closed
nosy: + serhiy.storchaka

resolution: rejected
stage: resolved
2020-09-17 23:14:18iritkatrielsetnosy: + iritkatriel
messages: + msg377073
2018-05-17 18:43:21scodersetnosy: + scoder
messages: + msg316975
2018-05-17 17:45:56stevoisiaksetmessages: + msg316969
2018-05-17 17:13:45stevoisiakcreate